<?php
#
#
if( !defined( 'MEDIAWIKI' ) ) { die(); }

$wgExtensionFunctions[] = "wfSlideshowExtension";

$wgExtensionCredits['other'][] = array(
	'name' => 'Slideshow',
	'author' => 'René Raule',
	'version' => '0.5',
	'url' => 'http://www.stargate-wiki.de/wiki/Benutzer:Rene/Slideshow',
	'description' => 'Create a slideshow from multiple images with jQuery Plugin Cycle'
);
 
$wgResourceModules['ext.slideshow'] = array(
	'scripts' => array('jquery.cycle.all.js','slideshow.js'),
	'styles' => 'slideshow.css',
	'dependencies' => array('jquery.ui.dialog'),
	'localBasePath' => dirname( __FILE__ ),
	'remoteExtPath' => 'Slideshow'
);

$imageIP = $wgScriptPath."/extensions/Slideshow";

function wfSlideshowExtension() {
	global $wgOut, $wgParser;

	$wgOut->addModules( 'ext.slideshow' );
	$wgParser->setHook( "slideshow", "renderSlideshow" );
}

function renderSlideshow( $wikitext, $options, $parser, $frame ) {
	global $imageIP,$wgOut,$wgUser,$wgThumbLimits;
	static $nummer = 0;
	$effects = array('blindx'=>'blindX','blindy'=>'blindY','blindz'=>'blindZ','cover'=>'cover',
		'curtainx'=>'curtainX','curtainy'=>'curtainY','fade'=>'fade','fadezoom'=>'fadeZoom',
		'growx'=>'growX','growy'=>'growY','none'=>'none','scrollup'=>'scrollUp','scrolldown'=>'scrollDown',
		'scrollleft'=>'scrollLeft','scrollright'=>'scrollRight','scrollhorz'=>'scrollHorz',
		'scrollvert'=>'scrollVert','shuffle'=>'shuffle','slidex'=>'slideX','slidey'=>'slideY',
		'toss'=>'toss','turnup'=>'turnUp','turndown'=>'turnDown','turnleft'=>'turnLeft',
		'turnright'=>'turnRight','uncover'=>'uncover','wipe'=>'wipe','zoom'=>'zoom');
	$buttons = array('prev','play','next','info','show');
	
	$nummer += 1;										// Zähler für eindeutige IDs, falls mehrere Shows auf einer Seite
	$ausgabe = '';
	// Default Werte für Parameter setzen
	$button = $buttons;									// Alle Button sollen gezeigt werden
	$start = true;										// Autostart der Show
	$effect = 'fade';									// Art der Überblendung
	$texthoehe = 24;									// Höhe des Textbereiches in Pixel
	$delay = 0;											// Zeitdiffenernz (+/-) beim Wechsel des ersten Bildes
	$speed = 1000;										// Dauer der Animation in ms
	$timeout = 4000;									// Pause in ms zwischen den Bildwechseln
	$random = 0;										// Zufällige Reihenfolge
	$hoehe = 0;											// Höhe des Show - Ohne Textbereich!
	$center = false;									// Bild zentrieren
	$texthoehe = 48;									// Höhe der Textbox
	$float = 'float: none; ';							// Ausrichtung der Show
	$mOptions = $wgUser->getOptions();					// Benutzer Einstellungen 
	$breite = $wgThumbLimits[$mOptions['imagesize']];	// Thumb-Breite aus Vorgabe holen
	// Übergabe-Parameter auswerten
	if( isset($options['width']) ) {					// Breite angegeben
		if( intval($options['width']) > 0 ) {			// Sinnvolle Breite
			$breite = intval($options['width']); 		// Breite setzen
		}
	}
	if( isset($options['nostart']) ) {					// Keine Autostart
		$start = false;									// setzen
	}
	if( isset($options['center']) ) {					// Zentrieren
		$center = true;									// setzen
	}
	if( isset($options['random']) ) {					// Zufällige Wiedergabe
		$random = 1;									// setzen
	}
	if( isset($options['effect']) ) {					// Effekt angegeben
		if( isset($effects[$options['effect']]) ) {		// prüfen ob erlaubter Wert
			$effect = $effects[$options['effect']];		// setzen
		}
	}
	if( isset($options['float']) ) {					// Float angegeben
		if( $options['float'] == 'left' ) $float = 'float: left; ';// setzen
		if( $options['float'] == 'right' ) $float = 'float: right; ';// setzen
	}
	if( isset($options['button']) ) {					// Button angegeben
		$button = explode(",",$options['button']);		// setzen
	}
	if( isset($options['delay']) ) {					// Delay angegeben
		if( is_numeric($options['delay']) ){			// Zahl?
			$delay = intval($options['delay']); 		// setzen
		}
	}
	if( isset($options['timeout']) ) {					// Pauseinterval angegeben
		if( intval($options['timeout']) >= 0 ) {		// Prüfen ob sinnvoll
			$timeout = intval($options['timeout']); 	// setzen
		}
	}
	if( isset($options['speed']) ) {					// Animationszeit angegeben
		if( intval($options['speed']) >= 0 ) {			// Prüfen ob sinnvoll
			$speed = intval($options['speed']); 		// setzen
		}
	}
	// 
	$show = ''; $imgclass = ''; $caption = ''; $mit_caption = false;
	// Alle Bilder einlesen und verarbeiten
	$zeilen = explode("\n",$wikitext);					// Wikitext in Zeilen aufspalten
	foreach($zeilen as $i => $zeile) {
		if( !empty($zeile) ) {							// Leerzeilen überlesen
			$para = explode("|",$zeile,2);				// Zeile in Parameter zerlegen
			$bild = wfFindFile($para[0]);				// Erster Parameter ist das Bild
			if( $bild ) {								// Wenn Bild gefunden
				if( $bild->getWidth() > $breite ) {		// Wenn Bild breiter als die Diashow, nur dann wird ein Thumbnail erzeigt
					$bildhoehe = ceil($bild->getHeight() * $breite / $bild->getWidth());	// Bildhöhe berechnen nach Verhältnis Sollbreite/Bildbreite
					$z = 0;
				} else {
					$bildhoehe = $bild->getHeight();	// sonst einfach Bildhöhe setzen
					$z = ceil(($breite - $bild->getWidth()) / 2);	// Rand berechnen (für center)
				}
				if( $bildhoehe > $hoehe ) { $hoehe = $bildhoehe; }	// Neue maximale Bildhöhe
				$thumb = $bild->createThumb($breite);				// Thumb erzeugen
				$data  = 'data-wikipage="'.$bild->getDescriptionUrl().'"';
				$data .= ' data-link="'.$bild->getURL().'"';
				$data .= ' data-width="'.$bild->getWidth().'"';
				$data .= ' data-height="'.$bild->getHeight().'"';
				$zclass = $center ? "margin-left: {$z}px;" : "";
				$show .= '<img src="'.$thumb.'" id="slideshow-image-'.$nummer.'-'.$i.'" class="slideshow-image" style="'.$zclass.' '.$imgclass.'" '.$data.">";
				if( empty($para[1])) { 
					$para[1] = '';
				} else {
					$mit_caption = true;
				}
				$caption .= HTML::rawElement('p',array('style'=>'display: none;','id'=>"slideshow-caption-{$nummer}-{$i}"),$parser->recursiveTagParse($para[1], $frame));
				$imgclass = 'display: none;';
			}
		}
	}
	// Platz für das Bild als Dialogbox
	if( $nummer == 1 ) $ausgabe .= HTML::rawElement('div',array('style'=>'display: none;','id'=>'slideshow-imagecontainer'),HTML::rawElement('img',array('id'=>'slideshow-bigimage')));
	// Wenn Bilder angegeben, Slideshow erzeugen
	if( !empty($show) ) {
		if( $mit_caption) $hoehe += $texthoehe;		// Platz für Text ergänzen
		// Slideshow erstellen 
		$breite += 30; $hoehe += 30; // Bildrahmen
		$ausgabe .= "<div id='slideshow-$nummer' style='$float width: {$breite}px; height: {$hoehe}px;' class='slideshow'>";
		$ausgabe .= "<div id='slides-$nummer' data-autostart='$start' data-cycle='{ \"slideExpr\": \"img\", \"random\": $random, \"fx\": \"$effect\", \"delay\": $delay, \"speed\": $speed, \"timeout\": $timeout }'>".$show."</div>";
		if( $mit_caption ) { $ausgabe .= "<div style='width: {$breite}px; height: {$texthoehe}px; overflow: hidden;'>$caption</div>"; }
		if( !empty($button) ) {
			$ausgabe .= "<div id='slideshow-controls-$nummer' style='display: none;' class='slideshow-controls'>";
			foreach($buttons as $value) {
				if( array_search($value,$button) !== false ) {
					$ausgabe .= "<button id='slideshow-controls-{$nummer}-{$value}'>";
					$ausgabe .= '<img src="'.$imageIP.'/player_'.$value.'.png">';
					$ausgabe .= '</button>';
					// Sonderfall play/pause
					if( $value == 'play' ) {
						$ausgabe .= "<button id='slideshow-controls-{$nummer}-pause'>";
						$ausgabe .= '<img src="'.$imageIP.'/player_pause.png">';
						$ausgabe .= '</button>';
					}
				}
			}
			$ausgabe .= '</div>';	// slidesshow-controls
		}
		$ausgabe .= '</div>';		// slideshow
	}
    $parser->disableCache();
    return $ausgabe;	
}

