mw.slideshow = {
	play: function(slides) {
		var controls = slides.replace('slides','slideshow-controls');
		$(slides).cycle('resume');
		$(controls+'-play').hide();
		$(controls+'-pause').show();
		return false;
	},
	pause: function(slides) {
		var controls = slides.replace('slides','slideshow-controls');
		$(slides).cycle('pause'); 
		$(controls+'-play').show();
		$(controls+'-pause').hide();
		return false;
	},
	buttonInfo: function(slides) {
		var a = $(slides).find('.slideshow-current');		// Aktuelles Bild der Show
		location.href = $(a).attr('data-wikipage');			// Link auslesen und aufrufen
		return false;
	},
	buttonShow: function(slides) {
		var controls = slides.replace('slides','slideshow-controls')+'-play';
		var play = $(controls).css('display');
		this.pause(slides);
		var a = $(slides).find('.slideshow-current');		// Aktuelles Bild der Show
		var w = Number($(a).attr('data-width'));
		var h = Number($(a).attr('data-height'));
		var image = $(a).attr('data-link');
		var f = w / h;	// Relation Bild-Höhe/Breite
		var wh = $(window).height() - 60; var ww = $(window).width() - 40;	// Browserfenster größe
		if( w > ww ) { w = ww; h = w / f; }		// Wenn Bild zu breit, anpassen
		if( h > wh ) { h = wh; w = h * f; }		// Wenn Bild zu hoch, anpassen
		$('#slideshow-bigimage').attr('src',image);	// Bild einlesen		
		$('#slideshow-bigimage').width(w);		// Breite setzen (Höhe ergibt sich daraus)
		// Dialog anzeigen
		$('#slideshow-imagecontainer').dialog({title: 'Ansicht schließen mit ESC Taste', modal: true, width: w+30, height: h+60,
		close: function(event,ui) {$('#slideshow-bigimage').attr('src',''); if( play == 'none' ) { mw.slideshow.play(slides); } } });
		return false;
	}
}

$(function() {
		$('.slideshow').each(function(index) {
				var id = '#'+$(this).attr('id');
				var slides = id.replace('slideshow','slides');
				var controls = id.replace('slideshow','slideshow-controls');
				$(slides).cycle({ prev: controls+'-prev', next: controls+'-next',
				before: function(curr,next,opt) { 
					$(this).parent().find('.slideshow-current').removeClass('slideshow-current');
					var curr_id = '#'+$(curr).attr('id'), next_id = '#'+$(next).attr('id');
					var curr_cap = curr_id.replace('image','caption'), next_cap = next_id.replace('image','caption');
					$(curr_cap).hide();
					$(next_cap).fadeIn(opt.speed);
				},
				after: function(c,n,o) { 
					$(this).addClass('slideshow-current'); 
				}
				});	// Alle Shows starten
				$(controls+'-pause').click(function() { return mw.slideshow.pause(slides) });
				$(controls+'-play').click(function() { return mw.slideshow.play(slides) });
				$(controls+'-info').click(function() { return mw.slideshow.buttonInfo(slides); });
				$(controls+'-show').click(function() { return mw.slideshow.buttonShow(slides); });
				$(id).hover( function() { $(controls).fadeIn('fast'); }, function() { $(controls).fadeOut('slow'); } ); // Controls Hover
				if($(slides).attr('data-autostart') == '1') { mw.slideshow.play(slides); } else { mw.slideshow.pause(slides); }
		});
});

